namespace eval ::colorednicks {

proc init { dir } {
	::plugins::RegisterPlugin "ColoredNicks"
	::plugins::RegisterEvent "ColoredNicks" parse_contact parsed_nick2
	status_log "ColoredNicks loaded"
}

proc parsed_nick2 {event epvar} {
	upvar 2 $epvar evpar
	upvar 2 $evpar(variable) nickArray
	
	variable email $evpar(login)
	variable newparsednick ""
	variable list_colors ""
	variable list_background_colors ""

	set parsednick $nickArray
	set num_elem [llength $parsednick]
	set element 0
	set thereisstyle 0
	for {set element 0} {$element < $num_elem} {incr element} {
		variable unit [lindex $parsednick $element]

		if {[lindex $unit 0] != "text"} {
			lappend newparsednick "[lindex $unit {}]"
		} else {
			set num_chars [string length [lindex $unit 1] ]
			variable buffer ""
			for {variable pos_char 0} {$pos_char<$num_chars} {incr pos_char} {
				set old_pos_char $pos_char
				variable char [string index [lindex $unit 1] $pos_char ]
				if {$char != "\[" && $char != "·"} {
					if {$char == "\{"} {
						append buffer "\{"
					} elseif {$char == "\}"} {
						append buffer "\}"
					} else {
						append buffer $char
					}
				} else {
					set next_char0 [string index [lindex $unit 1] $pos_char]
					if {$next_char0 == "\["} {
						set next_char1 [string range [lindex $unit 1] [expr $pos_char +1] [expr $pos_char +2] ]
						if {$next_char1 == "c="} {
							colored_nick
						} elseif { $next_char1 == "/c" } {
							faded_colored_nick
						} elseif { $next_char1 == "b]" } {
							unbuffer
							lappend newparsednick [list "bold"]
							incr pos_char 2
						} elseif { $next_char1 == "/b" } {
							set next_char2 [string index [lindex $unit 1] [expr $pos_char +3] ]
							if {$next_char2 == "\]"} {
								unbuffer
								lappend newparsednick [list "unbold"]
								incr pos_char 3
							}
						} elseif { $next_char1 == "s]" } {
							unbuffer
							lappend newparsednick [list "overstrike"]
							incr pos_char 2
						} elseif { $next_char1 == "/s" } {
							set next_char2 [string index [lindex $unit 1] [expr $pos_char +3] ]
							if {$next_char2 == "\]"} {
								unbuffer
								lappend newparsednick [list "unoverstrike"]
								incr pos_char 3
							}
						} elseif { $next_char1 == "u]" } {
							unbuffer
							lappend newparsednick [list "underline"]
							incr pos_char 2
						} elseif { $next_char1 == "/u" } {
							set next_char2 [string index [lindex $unit 1] [expr $pos_char +3] ]
							if {$next_char2 == "\]"} {
								unbuffer
								lappend newparsednick [list "ununderline"]
								incr pos_char 3
							}
						} elseif { $next_char1 == "i]" } {
							unbuffer
							lappend newparsednick [list "slant"]
							incr pos_char 2
						} elseif { $next_char1 == "/i" } {
							set next_char2 [string index [lindex $unit 1] [expr $pos_char +3] ]
							if {$next_char2 == "\]"} {
								unbuffer
								lappend newparsednick [list "unslant"]
								incr pos_char 3
							}
						} elseif { $next_char1 == "a=" } {
							nick_background
						} elseif { $next_char1 == "/a"} {
							faded_background_nick
						} elseif { $next_char1 == "B]" } {
							unbuffer
							lappend newparsednick [list "BOLD"]
							incr pos_char 2
						} elseif { $next_char1 == "/B" } {
							set next_char2 [string index [lindex $unit 1] [expr $pos_char +3] ]
							if {$next_char2 == "\]"} {
								unbuffer
								lappend newparsednick [list "UNBOLD"]
								incr pos_char 3
							}
						} elseif { $next_char1 == "S]" } {
							unbuffer
							lappend newparsednick [list "OVERSTRIKE"]
							incr pos_char 2
						} elseif { $next_char1 == "/S" } {
							set next_char2 [string index [lindex $unit 1] [expr $pos_char +3] ]
							if {$next_char2 == "\]"} {
								unbuffer
								lappend newparsednick [list "UNOVERSTRIKE"]
								incr pos_char 3
							}
						} elseif { $next_char1 == "U]" } {
							unbuffer
							lappend newparsednick [list "UNDERLINE"]
							incr pos_char 2
						} elseif { $next_char1 == "/U" } {
							set next_char2 [string index [lindex $unit 1] [expr $pos_char +3] ]
							if {$next_char2 == "\]"} {
								unbuffer
								lappend newparsednick [list "UNUNDERLINE"]
								incr pos_char 3
							}
						} elseif { $next_char1 == "I]" } {
							unbuffer
							lappend newparsednick [list "SLANT"]
							incr pos_char 2
						} elseif { $next_char1 == "/I" } {
							set next_char2 [string index [lindex $unit 1] [expr $pos_char +3] ]
							if {$next_char2 == "\]"} {
								unbuffer
								lappend newparsednick [list "UNSLANT"]
								incr pos_char 3
							}
						} elseif { $next_char1 == "A=" } {
							nick_background
						} elseif { $next_char1 == "/A"} {
							faded_background_nick
						}
					} elseif {$next_char0 == "·"} {
						set next_char1 [string index [lindex $unit 1] [expr $pos_char+1]]
						if { $next_char1 == "$"} {
							colored_nick_IRC_style
						} elseif {$next_char1 == "#"} {
							unbuffer
							lappend newparsednick [list font "-weight bold"]
							incr pos_char 1
						} elseif {$next_char1 == "@"} {
							unbuffer
							lappend newparsednick [list font "-underline 1"]
							incr pos_char 1
						} elseif {$next_char1 == "'"} {
							unbuffer
							lappend newparsednick [list font "-overstrike 1"]
							incr pos_char 1
						} elseif {$next_char1 == "&"} {
							unbuffer
							lappend newparsednick [list font "-slant italic"]
							incr pos_char 1
						} elseif {$next_char1 == "0"} {
							unbuffer
							lappend newparsednick [list font "-weight reset" "-slant reset" "-underline reset" "-overstrike reset"]
							incr pos_char 1
						}
					}
					if {$old_pos_char == $pos_char} {
						append buffer $char
					} else {
						set thereisstyle 1
					}
				}
			}
			if {$buffer != ""} {
				lappend newparsednick [list text $buffer]
			}
		}
	}

	if {$thereisstyle == 1} {
		set num_elem [expr [llength $newparsednick] -1]
		for {set element $num_elem} {$element >= 0} {incr element -1} {
			set unit [lindex $newparsednick $element]
			styleortext [lindex $unit 0] $element
		}
	
		set num_elem [expr [llength $newparsednick] -1]
		for {set element $num_elem} {$element >= 0} {incr element -1} {
			set unit [lindex $newparsednick $element]
			if {[lindex $unit 0] == "text" || [lindex $unit 0] == "colour"} {
			} elseif {[lindex $unit 0] == "bold"} {
				set newparsednick [lreplace $newparsednick $element $element [list text "\[b\]"]]
			} elseif {[lindex $unit 0] == "unbold"} {
				set newparsednick [lreplace $newparsednick $element $element [list text "\[/b\]"]]
			} elseif {[lindex $unit 0] == "overstrike"} {
				set newparsednick [lreplace $newparsednick $element $element [list text "\[s\]"]]
			} elseif {[lindex $unit 0] == "unoverstrike"} {
				set newparsednick [lreplace $newparsednick $element $element [list text "\[/s\]"]]
			} elseif {[lindex $unit 0] == "underline"} {
				set newparsednick [lreplace $newparsednick $element $element [list text "\[u\]"]]
			} elseif {[lindex $unit 0] == "ununderline"} {
				set newparsednick [lreplace $newparsednick $element $element [list text "\[/u\]"]]
			} elseif {[lindex $unit 0] == "slant"} {
				set newparsednick [lreplace $newparsednick $element $element [list text "\[i\]"]]
			} elseif {[lindex $unit 0] == "unslant"} {
				set newparsednick [lreplace $newparsednick $element $element [list text "\[/i\]"]]
			} elseif {[lindex $unit 0] == "BOLD"} {
				set newparsednick [lreplace $newparsednick $element $element [list text "\[B\]"]]
			} elseif {[lindex $unit 0] == "UNBOLD"} {
				set newparsednick [lreplace $newparsednick $element $element [list text "\[/B\]"]]
			} elseif {[lindex $unit 0] == "OVERSTRIKE"} {
				set newparsednick [lreplace $newparsednick $element $element [list text "\[S\]"]]
			} elseif {[lindex $unit 0] == "UNOVERSTRIKE"} {
				set newparsednick [lreplace $newparsednick $element $element [list text "\[/S\]"]]
			} elseif {[lindex $unit 0] == "UNDERLINE"} {
				set newparsednick [lreplace $newparsednick $element $element [list text "\[U\]"]]
			} elseif {[lindex $unit 0] == "UNUNDERLINE"} {
				set newparsednick [lreplace $newparsednick $element $element [list text "\[/U\]"]]
			} elseif {[lindex $unit 0] == "SLANT"} {
				set newparsednick [lreplace $newparsednick $element $element [list text "\[I\]"]]
			} elseif {[lindex $unit 0] == "UNSLANT"} {
				set newparsednick [lreplace $newparsednick $element $element [list text "\[/I\]"]]
			}
		}
		
		set style [list 0 0 0 0]
	
		set num_elem [expr [llength $newparsednick] -1]
		for {set element 0} {$element <= $num_elem} {incr element} {
			set unit [lindex $newparsednick $element]
			if {[lindex $unit 0] == "font"} {
				if {[lindex $unit 1] == "-weight bold"} {
					set style [lreplace $style 0 0 [expr [lindex $style 0] + 1]]
					if {[lindex $style 0] > 1} {
						set newparsednick [lreplace $newparsednick $element $element]
						incr element -1
					}
				} elseif {[lindex $unit 1] == "-weight reset"} {
					set style [lreplace $style 0 0 [expr [lindex $style 0] - 1]]
					if {[lindex $style 0] > 0} {
						set newparsednick [lreplace $newparsednick $element $element]
						incr element -1
					}
				} elseif {[lindex $unit 1] == "-overstrike 1"} {
					set style [lreplace $style 0 0 [expr [lindex $style 1] + 1]]
					if {[lindex $style 0] > 1} {
						set newparsednick [lreplace $newparsednick $element $element]
						incr element -1
					}
				} elseif {[lindex $unit 1] == "-overstrike reset"} {
					set style [lreplace $style 0 0 [expr [lindex $style 1] - 1]]
					if {[lindex $style 0] > 0} {
						set newparsednick [lreplace $newparsednick $element $element]
						incr element -1
					}
				} elseif {[lindex $unit 1] == "-underline 1"} {
					set style [lreplace $style 0 0 [expr [lindex $style 2] + 1]]
					if {[lindex $style 0] > 1} {
						set newparsednick [lreplace $newparsednick $element $element]
						incr element -1
					}
				} elseif {[lindex $unit 1] == "-underline reset"} {
					set style [lreplace $style 0 0 [expr [lindex $style 2] - 1]]
					if {[lindex $style 0] > 0} {
						set newparsednick [lreplace $newparsednick $element $element]
						incr element -1
					}
				} elseif {[lindex $unit 1] == "-slant italic"} {
					set style [lreplace $style 0 0 [expr [lindex $style 3] + 1]]
					if {[lindex $style 0] > 1} {
						set newparsednick [lreplace $newparsednick $element $element]
						incr element -1
					}
				} elseif {[lindex $unit 1] == "-slant reset"} {
					set style [lreplace $style 0 0 [expr [lindex $style 3] - 1]]
					if {[lindex $style 0] > 0} {
						set newparsednick [lreplace $newparsednick $element $element]
						incr element -1
					}
				}
			}
		}
	}

	set nickArray $newparsednick

	return 1
}


proc styleortext {unstyle element} {
	variable newparsednick

	set style [string range $unstyle 2 end]
	set origin_y [expr $element - 1]
	set old_elem $element
	for {set y $origin_y} {$y >= 0} {incr y -1} {
		set unit2 [lindex $newparsednick $y]
		if {[lindex $unit2 0] == $style} {
			set style [string tolower $style]
			if {$style == "bold"} {
				set in [list font "-weight bold"]
				set out [list font "-weight reset"]
			} elseif {$style == "overstrike"} {
				set in [list font "-overstrike 1"]
				set out [list font "-overstrike reset"]
			} elseif {$style == "underline"} {
				set in [list font "-underline 1"]
				set out [list font "-underline reset"]
			} elseif {$style == "slant"} {
				set in [list font "-slant italic"]
				set out [list font "-slant reset"]
			}

			set newparsednick [lreplace $newparsednick $old_elem $old_elem $out]
			set newparsednick [lreplace $newparsednick $y $y $in]
			set y $origin_y
			if {$old_elem == $element} { 
				break
			}
			set old_elem $element
		} elseif {[lindex $unit2 0] == $unstyle} {
			set old_elem $y
		}
	}
}


proc unbuffer {} {
	variable buffer
	variable newparsednick
	if {$buffer != ""} {
		lappend newparsednick [list text $buffer]
		set buffer ""
	}
}


proc colored_nick {} {
	variable unit
	variable pos_char
	variable list_colors
	variable newparsednick
	variable buffer
	variable char

	set next_char2 [string index [lindex $unit 1] [expr $pos_char +3] ]
	if {[string match \[0-9\] $next_char2]} {
		set colorcode "$next_char2"
		set next_char3 [string index [lindex $unit 1] [expr $pos_char +4] ]
		if {[string match \[0-9\] $next_char3]} {
			append colorcode $next_char3
		} else {
			set colorcode "0$colorcode"
		}
		if { $next_char3 == "\]" } {
			set color "#[getColor $colorcode]"
			lappend list_colors $color
			unbuffer
			lappend newparsednick "colour $color"
				incr pos_char 4
		} else {
			set next_char4 [string index [lindex $unit 1] [expr $pos_char +5] ]
			if {$next_char4 == "\]"} {
				set color "#[getColor $colorcode]"
				lappend list_colors $color
				unbuffer
				lappend newparsednick "colour $color"
				incr pos_char 5
			}
		}
	} elseif {$next_char2 == "#"} {
		set next_char3 [string index [lindex $unit 1] [expr $pos_char +10] ]
		if {$next_char3 == "\]"} {
			set color [string range [lindex $unit 1] [expr $pos_char+3] [expr $pos_char+9]]
			unbuffer
			lappend list_colors $color
			lappend newparsednick "colour $color"
			incr pos_char 10
		}
	}
}


proc faded_colored_nick {} {
	variable unit
	variable pos_char
	variable list_colors
	variable newparsednick
	variable buffer
	variable char
	variable email

	if {[llength $list_colors] == 0} { return 2 }

	set next_char2 [string index [lindex $unit 1] [expr $pos_char +3] ]
	if { $next_char2 == "\]" } {
		unbuffer
		last_colors 1
		incr pos_char 3
	} elseif { $next_char2 == "=" } {
		set next_char3 [string index [lindex $unit 1] [expr $pos_char +4]]
		if {$next_char3 == "#"} {
			set next_char4 [string index [lindex $unit 1] [expr $pos_char +11] ]
			if {$next_char4 == "\]"} {
				set color [string range [lindex $unit 1] [expr $pos_char+4] [expr $pos_char+10]]
				unbuffer
				lappend list_colors $color
				fade
				incr pos_char 11
			}
		} elseif {[string match \[0-9\] $next_char3]} {
			set colorcode "$next_char3"
			set next_char4 [string index [lindex $unit 1] [expr $pos_char +5] ]
			if {[string match \[0-9\] $next_char4]} {
				append colorcode $next_char4
			} else {
				set colorcode "0$colorcode"
			}
			if { $next_char4 == "\]" } {
				set color "#[getColor $colorcode]"
				lappend list_colors $color
				unbuffer
				fade
				incr pos_char 5
			} else {
				set next_char5 [string index [lindex $unit 1] [expr $pos_char +6] ]
				if {$next_char5 == "\]"} {
					set color "#[getColor $colorcode]"
					lappend list_colors $color
					unbuffer
					fade
					incr pos_char 6
				}
			}
		}
	}
}


proc nick_background {} {
	variable unit
	variable pos_char
	variable list_background_colors
	variable newparsednick
	variable buffer
	variable char

	set next_char2 [string index [lindex $unit 1] [expr $pos_char +3] ]
	if {[string match \[0-9\] $next_char2]} {
		set colorcode "$next_char2"
		set next_char3 [string index [lindex $unit 1] [expr $pos_char +4] ]
		if {[string match \[0-9\] $next_char3]} {
			append colorcode $next_char3
		} else {
			set colorcode "0$colorcode"
		}
		if { $next_char3 == "\]" } {
			set color "#[getColor $colorcode]"
			lappend list_background_colors $color
			unbuffer
			lappend newparsednick "background $color"
			incr pos_char 4
		} else {
			set next_char4 [string index [lindex $unit 1] [expr $pos_char +5] ]
			if {$next_char4 == "\]"} {
				set color "#[getColor $colorcode]"
				lappend list_background_colors $color
				unbuffer
				lappend newparsednick "background $color"
				incr pos_char 5
			}
		}
	} elseif {$next_char2 == "#"} {
		set next_char3 [string index [lindex $unit 1] [expr $pos_char +10] ]
		if {$next_char3 == "\]"} {
			set color [string range [lindex $unit 1] [expr $pos_char+3] [expr $pos_char+9]]
			lappend list_background_colors $color
			unbuffer	
			lappend newparsednick "background $color"
			incr pos_char 10
		}
	}
}


proc faded_background_nick {} {
	variable unit
	variable pos_char
	variable list_background_colors
	variable newparsednick
	variable buffer
	variable char
	variable email

	if {[llength $list_background_colors] == 0} { return 2 }

	set next_char2 [string index [lindex $unit 1] [expr $pos_char +3] ]
	if { $next_char2 == "\]" } {
		unbuffer
		set lung_list_colors "[llength $list_background_colors]"
		if {$lung_list_colors < 2} {
			set state_code [::abook::getVolatileData $email state FLN]
			if { $state_code == "FLN" && [::abook::getContactData $email msn_mobile] == "1" } {
				set color [::skin::getKey "contact_mobile"]
			} else {
				set color [::MSN::stateToColor $state_code "contact"]
			}
		} else {
			set color [lindex $list_background_colors [expr $lung_list_colors -2 ] ]
		}
		set list_background_colors "[lreplace $list_background_colors end end]"
		lappend newparsednick "background $color"
		incr pos_char 3
	} elseif { $next_char2 == "=" } {
		set next_char3 [string index [lindex $unit 1] [expr $pos_char +4]]
		if {$next_char3 == "#"} {
			set next_char4 [string index [lindex $unit 1] [expr $pos_char +11] ]
			if {$next_char4 == "\]"} {
				set color [string range [lindex $unit 1] [expr $pos_char+4] [expr $pos_char+10]]
				unbuffer
				lappend list_background_colors $color
	#			fade
				incr pos_char 11
			}
		} elseif {[string match \[0-9\] $next_char3]} {
			set colorcode "$next_char3"
			set next_char4 [string index [lindex $unit 1] [expr $pos_char +5] ]
			if {[string match \[0-9\] $next_char4]} {
				append colorcode $next_char4
			} else {
				set colorcode "0$colorcode"
			}
			if { $next_char4 == "\]" } {
				set color "#[getColor $colorcode]"
				lappend list_colors $color
				unbuffer
	#			fade
				incr pos_char 5
			} else {
				set next_char5 [string index [lindex $unit 1] [expr $pos_char +6] ]
				if {$next_char5 == "\]"} {
					set color "#[getColor $colorcode]"
					lappend list_background_colors $color
					unbuffer
	#				fade
					incr pos_char 6
				}
			}
		}
	}
}


proc colored_nick_IRC_style {} {
	variable unit
	variable pos_char
	variable list_colors
	variable newparsednick
	variable buffer
	variable char

	set old_pos_char $pos_char
	set next_char2 [string index [lindex $unit 1] [expr $pos_char +2] ]
	if {[string match \[0-9\] $next_char2]} {
		set colorcode "$next_char2"
		set next_char3 [string index [lindex $unit 1] [expr $pos_char +3] ]
		if {[string match \[0-9\] $next_char3]} {
			append colorcode $next_char3
			incr pos_char 3
		} else {
			set colorcode "0$colorcode"
			incr pos_char 2
		}

		set color "#[getColor $colorcode]"
		lappend list_colors $color
		unbuffer
		lappend newparsednick "colour $color"
	} elseif {$next_char2 == "#"} {
		set color [string range [lindex $unit 1] [expr $pos_char + 2] [expr $pos_char +8]]
		lappend list_colors $color
		unbuffer
		lappend newparsednick "colour $color"
		incr pos_char 8
	} elseif {$next_char2 == "("} {
		set color [string range [lindex $unit 1] [expr $pos_char +2] [expr $pos_char +14]]
		if {[string match "(\[0-9\]\[0-9\]\[0-9\],\[0-9\]\[0-9\]\[0-9\],\[0-9\]\[0-9\]\[0-9\])" $color] } {
			scan $color "(%3u,%3u,%3u)" red green blue
			set color [format "#%02X%02X%02X" $red $green $blue]
			lappend list_colors $color
			unbuffer
			lappend newparsednick "colour $color"
			incr pos_char 14
		}
	}

	if {$old_pos_char != $pos_char} {
		set next_char4 [string index [lindex $unit 1] [expr $pos_char +1] ]
		if { $next_char4 == "," } {
			set next_char5 [string index [lindex $unit 1] [expr $pos_char +2] ]
			if {[string match \[0-9\] $next_char5]} {
				set colorcode "$next_char5"
				set next_char6 [string index [lindex $unit 1] [expr $pos_char +3] ]
				if {[string match \[0-9\] $next_char6]} {
					append colorcode $next_char6
					incr pos_char 3
				} else {
					set colorcode "0$colorcode"
					incr pos_char 2
				}
			}
		}
	}
}


proc fade {} {
	variable newparsednick
	variable list_colors

	set lung_list_colors [llength $list_colors]
	set penultimate_color [lindex $list_colors [expr $lung_list_colors-2]]
	set last_color [lindex $list_colors [expr $lung_list_colors-1]]
	set lung_newparsednick [llength $newparsednick]

	set same_color 0
	for {set x 0} {$x < $lung_list_colors} {incr x} {
		if {[lindex $list_colors $x] == $penultimate_color} {
			incr same_color 1
		}
	}

	set num_chars 0
	set element 0
	set num_elem $lung_newparsednick
	set pos 0

	for {set element 0} {$element < $num_elem} {incr element} {
		set unit [lindex $newparsednick $element]
		if {[lindex $unit 0] == "colorcode"} {
			if { [lindex $unit 1] == $penultimate_color} {
				if {$same_color == 1} {
					set pos $element
				} else {
					incr same_color -1
				}
			}
		}
	}

	incr pos 1
	for {set x $pos} {$x < $num_elem} {incr x} {
		set unit [lindex $newparsednick $x]
		if {[lindex $unit 0] == "smiley"} {
			set num_chars "[expr $num_chars + [string length [lindex $unit 2] ] ]"
		} elseif {[lindex $unit 0] == "text"} {
			set num_chars "[expr $num_chars + [string length [lindex $unit 1] ] ]"
		}
	}

	set pen "[expr 0x[string range $penultimate_color 1 2]] [expr 0x[string range $penultimate_color 3 4]] [expr 0x[string range $penultimate_color 5 6]]"
	set last "[expr 0x[string range $last_color 1 2]] [expr 0x[string range $last_color 3 4]] [expr 0x[string range $last_color 5 6]]"

	set diff "[expr [lindex $last 0] - [lindex $pen 0]] [expr [lindex $last 1] - [lindex $pen 1]] [expr [lindex $last 2] - [lindex $pen 2]]"

	set quantity ""
	set num_chars "[expr $num_chars + 0.00]"

	if { $num_chars > 1} {
		set num_chars "[expr $num_chars - 1]"
	} elseif { $num_chars == 0} {
		last_colors 2
		return 2
	}
	for {set x 0} {$x<3} {incr x} {
		if {[lindex $diff $x] > 0} {
			set result [expr [lindex $diff $x] / $num_chars]
		} elseif {[lindex $diff $x] < 0} {
			set result [expr [expr [expr [lindex $diff $x] * -1 ] / $num_chars] * -1]
		} else {
			set result 0
		}
		lappend quantity $result
	}

	set tempparsednick ""

	for {set x 0} {$x < $pos} {incr x} {
		set unit [lindex $newparsednick $x]
		lappend tempparsednick "[lindex $unit {}]"
	}

	set num_chars_done 0
	for {set x $pos} {$x < $lung_newparsednick && $num_chars_done <= $num_chars} {incr x} {
		set unit [lindex $newparsednick $x]
		if {[lindex $unit 0] == "smiley"} {
			lappend tempparsednick "[lindex $unit {}]"
			incr num_chars_done [string length [lindex $unit 2] ]
		} elseif {[lindex $unit 0] == "text"} {
			set lung_text [string length [lindex $unit 1] ]
			for {set y 0} {$y < $lung_text} {incr y} {
				set char [string index [lindex $unit 1] $y]
				set color "#"
				for {set z 0} {$z < 3} {incr z} {
					if {$y == 0} {
						set p [lindex $pen $z]
					} else {
						set p [expr [lindex $pen $z] + [lindex $quantity $z]]
						set pen [lreplace $pen $z $z $p]
					}
					set p [format "%0.0f" $p]
					if {$p < 16} {
						set p "0[format %x $p]"
					} else {
						set p [format %x $p]
					}

					append color $p
				}
				lappend tempparsednick "colour $color"
				lappend tempparsednick [list text $char]
			}
			incr num_chars_done 1
		} else {
			lappend tempparsednick [lindex $newparsednick $x]
		}
	}

	set newparsednick $tempparsednick

	last_colors 2
}


proc last_colors {p} {
	variable list_colors
	variable newparsednick
	variable email

	set list_colors "[lreplace $list_colors end end]"
	if {$p == 2} {
		set list_colors "[lreplace $list_colors end end]"
	}

	set lung_list_colors "[llength $list_colors]"
	if {$lung_list_colors == 0} {
		set state_code [::abook::getVolatileData $email state FLN]
		if { $state_code == "FLN" && [::abook::getContactData $email msn_mobile] == "1" } {
			set color [::skin::getKey "contact_mobile"]
		} else {
			set color [::MSN::stateToColor $state_code "contact"]
		}
	} else {
		set color [lindex $list_colors end ]
	}

	lappend newparsednick "colour $color"
}


proc getColor { num } {
	if {$num < 34} {
		array set colors [list  \
			00 "FFFFFF" 01 "000000" 02 "00007F" 03 "009300" 04 "FF0000" \
			05 "7F0000" 06 "9C009C" 07 "FC7F00" 08 "FFFF00" 09 "00FC00" \
			10 "009393" 11 "00FFFF" 12 "2020FC" 13 "FF00FF" 14 "7F7F7F" \
			15 "D2D2D2" 16 "E7E6E4" 17 "CFCDD0" 18 "FFDEA4" 19 "FFAEB9" \
			20 "FFA8FF" 21 "B4B4FC" 22 "BAFBE5" 23 "C1FFA3" 24 "FAFDA2" \
			25 "B6B4D7" 26 "A2A0A1" 27 "F9C152" 28 "FF6D66" 29 "FF62FF" \
			30 "6C6CFF" 31 "68FFC3" 32 "8EFF67" 33 "F9FF57" ]
	} else {
		array set colors [list  \
			34 "858482" 35 "6E6B7D" 36 "FFA01E" 37 "F92611" 38 "FF20FF" \
			39 "202BFF" 40 "1EFFA5" 41 "60F913" 42 "FFF813" 43 "5E6464" \
			44 "4B494C" 45 "D98812" 46 "EB0505" 47 "DE00DE" 48 "0000D3" \
			49 "03CC88" 50 "59D80D" 51 "D4C804" 52 "000268" 53 "18171C" \
			54 "944E00" 55 "9B0008" 56 "980299" 57 "01038C" 58 "01885F" \
			59 "389600" 60 "9A9E15" 61 "473400" 62 "4D0000" 63 "5F0162" \
			64 "000047" 65 "06502F" 66 "1C5300" 67 "544D05" ]
	}

	if { [info exists colors($num)] } {
		return [set colors($num)]
	} else {
		variable list_colors
		return [string range [lindex $list_colors end] 1 end]
	}
}


proc deinit {} {
}

}

