###########################################################################
# License: GNU General Public License
#
# Plugin written by: Zhu Hengguo
# Comments: zhuhengguo@gmail.com
# Version: 0.1 2006-5-24  
###########################################################################
	

namespace eval ::msntranslator {
		
		
  ###########################################################################
  #  gobal variables
  ###########################################################################
		
  variable loaded 0
  variable auto_translate_started 0

	
 	
		
  ###########################################################################
  #
  # The initial procedure called when the plugin is started by AMSN
	#	
  ###########################################################################
	
 
	proc init { dir }	{


		::plugins::RegisterPlugin "msntranslator"
      



		variable loaded


		if { $loaded == 1 } { return 0 }
		
		#Save in a config key where is the msntranslator plugin
		::config::setKey msntranslatorpluginpath $dir
	    	
		#Get default value for config
		::msntranslator::config_array
	  	
		set langdir [append dir "/lang"]
		set lang [::config::getGlobalKey language]
		#It's important to load the english file and then the current language lang file
		load_lang en $langdir
		
		
	#	plugins_log "msntranslator" 	$lang
		
		load_lang $lang $langdir

		#Config to show in configuration window	
		::msntranslator::configlist_values
		
	  status_log "ok here  $::msntranslator::config(my_language_set)"	
		
		# Register event when change status
		 ::msntranslator::RegisterEvent	
		

	#	plugins_log $plugin_name "Plugin loaded ok"

	#	set loaded 1
	#	plugins_log $plugin_name "Plugin loaded"
	#	return 1
		
	}
	
	

	##############################################################################
  # The deinitial procedure called when the plugin is unload by AMSN
	#
	##############################################################################	
	
	proc deInit {} {
		
		# Unregister the events from the plugin
		
		::plugins::UnRegisterEvents "msntranslator"
		
	#	variable loaded

	#	if { $loaded == 0 } { return 0 }

	#	set loaded 0		
		
		plugins_log "msntranslator" "plugin unregistered"
		
	}
	

	
	
	##############################################################################
	# ::msntranslator::config_array                
	# -------------------------------------
	# Add config array with default values 
	##############################################################################
		proc config_array {} {
	
		array set ::msntranslator::config { 
		   my_language_set {zh}
       the_other_language_set {en} 
       translate_website_set {systranbox}   
    }	

  
  }	
	



	##############################################################################
	# ::msntranslator::configlist_values          
	# -------------------------------------       
	# List of items for config window              
	##############################################################################
	proc configlist_values {} {
		set ::msntranslator::configlist [list \
			[list str "my language " my_language_set ] \
			[list str "the other language " the_other_language_set] \
			[list str "translate website" translate_website_set] \
		]
	}
	

	
	#########################################################################
	# ::msntranslator::RegisterEvent            
	# --------------------------------- 
	# Register events to plugin system  
	#########################################################################
	
	proc RegisterEvent {} {
		::plugins::RegisterEvent "msntranslator" new_chatwindow add_right_menu	
		::plugins::RegisterEvent "msntranslator" chat_msg_received received_event
		
		#maybe chat_msg_send event better ,because the other one needn't the orginal text
		::plugins::RegisterEvent "msntranslator" chat_msg_sent sent_event
		
		
	}
	


	
	##########################################################################
	# Add menu items to the rightbutton menu
	#
	##########################################################################
	
	
	proc add_right_menu { event evpar } {
		upvar 2 $evpar args
		
		plugins_log "msntranslator" "Add buttons to window"
			
		#Define variables
		set w $args(win)
		set copymenu $w.copy

		$copymenu add cascade -label "msntranslator" -menu $copymenu.msntranslator
		menu $copymenu.msntranslator -tearoff 0 -type normal
		
		$copymenu.msntranslator add cascade -label "auto_translate" -menu $copymenu.msntranslator.auto_translate
		menu $copymenu.msntranslator.auto_translate -tearoff 0 -type normal
		
		$copymenu.msntranslator.auto_translate add command -label "start" -command "::msntranslator::start_auto_translate $w"	
		$copymenu.msntranslator.auto_translate add command -label "stop" -command "::msntranslator::stop_auto_translate $w "	
		
		
		$copymenu.msntranslator add cascade -label "my_langangue" -menu $copymenu.msntranslator.my_langangue
		menu $copymenu.msntranslator.my_langangue -tearoff 0 -type normal
		
		#	ar         Arabic  
		$copymenu.msntranslator.my_langangue add command -label "Arabic" \
		     -command "msntranslator::my_langangue_seter $w ar   "
		     
		#de         German   
		$copymenu.msntranslator.my_langangue add command -label "German" \
		     -command "msntranslator::my_langangue_seter $w de   "
		     
		#el         Greek  ϣ           
		$copymenu.msntranslator.my_langangue add command -label "Greek" \
		     -command "msntranslator::my_langangue_seter $w el   "
		     
		#en         English Ӣ
		$copymenu.msntranslator.my_langangue add command -label "English" \
		     -command "msntranslator::my_langangue_seter $w en   "
		     
		#es         Spanish 
		$copymenu.msntranslator.my_langangue add command -label "Spanish" \
		     -command "msntranslator::my_langangue_seter $w es   "
		     
		#fr         French 
		$copymenu.msntranslator.my_langangue add command -label "French" \
		     -command "msntranslator::my_langangue_seter $w fr   "
		     
		#it         Italian  
		$copymenu.msntranslator.my_langangue add command -label "Italian" \
		    -command "msntranslator::my_langangue_seter $w it   "
		    
		#ja         Japanese  
		$copymenu.msntranslator.my_langangue add command -label "Japanese" \
		    -command "msntranslator::my_langangue_seter $w ja   "
		    
		#ko         Korean    
		$copymenu.msntranslator.my_langangue add command -label "Korean" \
		    -command "msntranslator::my_langangue_seter $w ko   "
		    
		#nl         Dutch    
		$copymenu.msntranslator.my_langangue add command -label "Dutch" \
		    -command "msntranslator::my_langangue_seter $w nl   "
		
		#pt         Portuguese 
		$copymenu.msntranslator.my_langangue add command -label "Portuguese" \
		   -command "msntranslator::my_langangue_seter $w pt   "
		   
		#ru         Russian   
		$copymenu.msntranslator.my_langangue add command -label "Russian" \
		   -command "msntranslator::my_langangue_seter $w ru   "
		   
		#zh        Chinese-simp ()
		$copymenu.msntranslator.my_langangue add command -label "Chinese-simp" \
		   -command "msntranslator::my_langangue_seter $w zh   "
		   
		#zt         Chinese-trad ()                
		$copymenu.msntranslator.my_langangue add command -label "Chinese-trad" \
		    -command "msntranslator::my_langangue_seter $w zt   "

		$copymenu.msntranslator add cascade -label "the_other_langangue" -menu $copymenu.msntranslator.the_other_langangue
		menu $copymenu.msntranslator.the_other_langangue -tearoff 0 -type normal
		#	ar         Arabic  
		$copymenu.msntranslator.the_other_langangue add command -label "Arabic" \
		    -command "msntranslator::the_other_langangue_seter $w ar   "
		#de         German   
		$copymenu.msntranslator.the_other_langangue add command -label "German" \
		   -command "msntranslator::the_other_langangue_seter $w de   "
		#el         Greek'           
		$copymenu.msntranslator.the_other_langangue add command -label "Greek" \
		    -command "msntranslator::the_other_langangue_seter $w el   "
		#en         English Ӣ
		$copymenu.msntranslator.the_other_langangue add command -label "English" \
		   -command "msntranslator::the_other_langangue_seter $w en   "
		#es         Spanish 
		$copymenu.msntranslator.the_other_langangue add command -label "Spanish" \
		    -command "msntranslator::the_other_langangue_seter $w es   "
		#fr         French 
		$copymenu.msntranslator.the_other_langangue add command -label "French" \
		    -command "msntranslator::the_other_langangue_seter $w fr   "
		#it         Italian  
		$copymenu.msntranslator.the_other_langangue add command -label "Italian" \
		    -command "msntranslator::the_other_langangue_seter $w it   "
		#ja         Japanese  
		$copymenu.msntranslator.the_other_langangue add command -label "Japanese" \
		    -command "msntranslator::the_other_langangue_seter $w ja   "
		#ko         Korean    
		$copymenu.msntranslator.the_other_langangue add command -label "Korean" \
		    -command "msntranslator::the_other_langangue_seter $w ko   "
		#nl         Dutch    
		$copymenu.msntranslator.the_other_langangue add command -label "Dutch" \
		    -command "msntranslator::the_other_langangue_seter $w nl   "
		#pt         Portuguese 
		$copymenu.msntranslator.the_other_langangue add command -label "Portuguese" \
		    -command "msntranslator::the_other_langangue_seter $w pt   "
		#ru         Russian   
		$copymenu.msntranslator.the_other_langangue add command -label "Russian" \
		    -command "msntranslator::the_other_langangue_seter $w ru   "
		#zh        Chinese-simp ()
		$copymenu.msntranslator.the_other_langangue add command -label "Chinese-simp" \
		    -command "msntranslator::the_other_langangue_seter $w zh   "
		#zt         Chinese-trad ()                
		$copymenu.msntranslator.the_other_langangue add command -label "Chinese-trad" \
		    -command "msntranslator::the_other_langangue_seter $w zt   "
                 		
		$copymenu.msntranslator add cascade -label "translate_test" -menu $copymenu.msntranslator.translate_test
		menu $copymenu.msntranslator.translate_test -tearoff 0 -type normal
		
		$copymenu.msntranslator.translate_test add command -label "test" -command "::msntranslator::auto_translate_test $w"	
                 		
		
	}
	

	#################################################################
	# change the auto translate switch to start
	#
	#################################################################
	proc start_auto_translate { w } {
	   status_log "start auto translate " 
	   
		set ::msntranslator::auto_translate_started 1
		say_it_in_my_screen $w "auto translate opened"
		
		#say_it_in_the_other_one_screen $w "auto translate opened"	
	   
		say_it_in_the_other_one_screen $w "? "	
	   
	}

	
	#################################################################
	# change the auto translate switch to stop
	#
	#################################################################
	
	proc stop_auto_translate { w } {
		set ::msntranslator::auto_translate_started 0
		say_it_in_my_screen $w "auto translate stoped"
		say_it_in_the_other_one_screen $w "auto translate stoped"
	}
	
	
	################################################################
	# set my language
	# 	
	#################################################################
	
	proc my_langangue_seter { w selected_language } {
	
	    status_log $selected_language
      set ::msntranslator::config(my_language_set) $selected_language


	    status_log "you have changed your language as $::msntranslator::config(my_language_set) "
			say_it_in_my_screen $w "you have changed your language as  $selected_language "

	}
	
	#################################################################
	# set the other language
	# 	
	#################################################################
	
	proc the_other_langangue_seter {w selected_language } {
	
      set ::msntranslator::config(the_other_language_set) $selected_language
			
			say_it_in_my_screen $w "you have changed the other language as $selected_language "
    
	}	
	
	
	
	
	
     
  ##########################################################################################################   
  # Catch message received event, and get the received message.
  #
  ##########################################################################################################   
 
	proc received_event {event evpar } {

   #chat_msg_received -> user nick msg -> after a message is recieved 
		#I don't know why can not be nick  , if I need check it?  
		#the document is old ,no nick but chatid

		upvar 2 $evpar args
		upvar 2 $args(user) user
		upvar 2 $args(chatid) chatid		
		upvar 2 $args(msg) msg
 		
		#why I received what my sended
		# need to avoid it
		set myuser [::abook::getPersonal login]
 # status_log "I received somthing from $user "
		
		
	#	status_log "my user id is $myuser "
		if { $user==$myuser } { return } 
	   status_log "I received only $user $msg "	

	 # this line only for debug ,it is not need 
	 # say_it_in_my_screen_by_chatid $chatid "I received $user $msg "

  		if { $::msntranslator::auto_translate_started == 1 } {  
  		    set translate_result [translate_received_message $msg]
  		    status_log "I receive the translate reault $translate_result"
					say_it_in_my_screen_by_chatid $chatid $translate_result
	    }
	    
	    
	}
	

  ##########################################################################################################   
	# Catch send message button event, and get sended message
	#
  ##########################################################################################################   
	
	proc sent_event { event evpar } {
   
    #chat_msg_sent -> nick msg chatid win_name fontfamily fontcolor fontstyle -> after a message is sent 
    
    #if we use chat_msg_send event ,we can change msg direct

		upvar 2 $evpar args
		upvar 2 $args(chatid) chatid
		#upvar 2 $args(nick) nick
		upvar 2 $args(msg) msg

     status_log "ok I send this message $msg "
     
     
  		if { $::msntranslator::auto_translate_started == 1 } {  
  		     set translate_result [ translate_sended_message $msg ]
  		       		    
  		     status_log "I send the translate reault $translate_result"

  		     
    			 say_it_in_the_other_one_screen_by_chatid $chatid $translate_result
					say_it_in_my_screen_by_chatid $chatid $translate_result
    	}
    
	}
		
	
	

	
  ##########################################################################################################   
	#Say it in My screen
	#
  ##########################################################################################################   
	
	proc say_it_in_my_screen { w str } {
	
	   say_it_in_my_screen_by_chatid [::ChatWindow::Name $w] $str
	}
	
	
  ##########################################################################################################   
	#Say it in My screen by chatid
	#
  ##########################################################################################################   
	
	proc say_it_in_my_screen_by_chatid { chatid str } {
		# Write a seperated line to the chat window
		# Versions above 0.94 can use a graphical build-in line so I use this call
		::amsn::WinWrite $chatid "\n" green
			
		# Write a seperated line to the chat window
		# Versions above 0.94 can use a graphical build-in line so I use this call
		if { $::version == "0.94" } {
				::amsn::WinWrite $chatid "--------------------------------------------------" gray_italic	 
		} else {
				::amsn::WinWriteIcon $chatid greyline 3 
		} 
		::amsn::WinWrite $chatid "\n" green
		::amsn::WinWriteIcon $chatid miniinfo 
		::amsn::WinWrite $chatid "It seems to say : " green
		::amsn::WinWrite $chatid "\n" green
		
		::amsn::WinWrite $chatid $str blue
		::amsn::WinWrite $chatid "\n" green
		
		::amsn::WinWrite $chatid "auto translated by msntranslator" green
		
		# Write a seperated line to the chat window
		# Versions above 0.94 can use a graphical build-in line so I use this call
		if { $::version == "0.94" } {
				::amsn::WinWrite $chatid "--------------------------------------------------\n" gray_italic	 
		} else {
				::amsn::WinWriteIcon $chatid greyline 3 
		} 
		
	}		
	
	

  ##########################################################################################################   	
	# Say it in the other one window
	# It is the same with  amsn::MessageSend but not fire any event 
	# Maybe if I only change msg before send in the chat_send event ,is better
  ##########################################################################################################   
	
	proc say_it_in_the_other_one_screen { win_name   custom_msg } {
			
			set chatid [::ChatWindow::Name $win_name]
	    say_it_in_the_other_one_screen_by_chatid $chatid $custom_msg
 
   }  	
	

  ##########################################################################################################   	
	# Say it in the other one window
	# It is the same with  amsn::MessageSend but not fire any event 
	# Maybe if I only change msg before send in the chat_send event ,is better
  ##########################################################################################################   	
	
	
	proc say_it_in_the_other_one_screen_by_chatid { chatid   custom_msg } {
	
			#we can not use this ,::amsn::MessageSend $w $str
				# win_name input {custom_msg ""} {friendlyname ""}	
				#because MessageSend will fire event chat_msg_send or chat_msg_sent
				#to avoid that we use ::MSN::messageTo directly
			
		set ackid 0
	
		if { $chatid == 0 } {
			status_log "VERY BAD ERROR in ::amsn::MessageSend!!!\n" red
			return 0
		}

		if { $custom_msg != "" } {
			set msg $custom_msg
		} else {
		  return 0 
		}

		#Blank message
		if {[string length $msg] < 1} { return 0 }


	
			    #I don't know the means of $friendlyname
			    
		status_log "I will send  $custom_msg"	    
		::MSN::messageTo $chatid $custom_msg $ackid 

		
	}
	
	
  
  ##########################################################################################################   	
  # translate received message
  #
  ##########################################################################################################   	
  
  proc translate_received_message { receieved_message_text } { 
  
     set translate_source_language $::msntranslator::config(the_other_language_set)
     set translate_destination_language $::msntranslator::config(my_language_set)
     set translate_used_website $::msntranslator::config(translate_website_set)
  status_log "msntranslator begin translate_received_message ok "
     
     set retVal [translate_text $receieved_message_text $translate_source_language \
                  $translate_destination_language $translate_used_website ]
     
    
     
     return $retVal
  
  }
  	
 
  
  ##########################################################################################################   	
  # translate sended message
  #
  ##########################################################################################################   	
  
  
  proc translate_sended_message { sended_message_text } {
     set translate_source_language $::msntranslator::config(my_language_set)
     set translate_destination_language $::msntranslator::config(the_other_language_set)
     set translate_used_website $::msntranslator::config(translate_website_set)
     
     set retVal [translate_text $sended_message_text $translate_source_language \
                  $translate_destination_language $translate_used_website ]
  
     
     
     #set retVal [translate_text_asynchronously $sended_message_text $translate_source_language \
     #             $translate_destination_language $translate_used_website ]
     
     
     return $retVal
  }	
	
	





  ##########################################################################################################   	
  # translate text
  # 
  ##########################################################################################################   	


  proc translate_text { searchText translate_source_language translate_destination_language translate_used_website } {
  
     set retVal [ translate_text_with_systranbox $searchText $translate_source_language $translate_destination_language $translate_used_website ]
    # set retVal [ translate_text_with_altavista $searchText $translate_source_language $translate_destination_language $translate_used_website ]
    # set retVal [ translate_text_with_google $searchText $translate_source_language $translate_destination_language $translate_used_website ]
    
    
    return $retVal
    
  }

 
 
  ##########################################################################################################   	
  # translate text asynchronously 
  # In here I first call a check loop while result respense or timeout  
  ##########################################################################################################   	

  variable transltate_finished
  variable translate_result 
  variable req
 proc translate_text_asynchronously { searchText translate_source_language translate_destination_language translate_used_website } {
       
       
    set ::msntranslator::transltate_finished 0
    set ::msntranslator::translate_result ""
    translate_text_with_systranbox_with_tcom  $searchText $translate_source_language $translate_destination_language $translate_used_website 
    variable timeout
    set timeout 0
    while { $::msntranslator::transltate_finished == 0 } {
      after 100
      incr timeout  100 
      if {$timeout > 1500 } { break }
    }
    status_log "msntranslator translate result is $::msntranslator::translate_result"
    return $::msntranslator::translate_result
    
       
  }

 
  ##########################################################################################################   	
  # translate text use systranbox website and tcom package
  # 
  #   I don't know why the ::http return chinese charset have problem 
  #   I'm very sorry to say, let's begin with activex XMLHttpRequest. Thank chin huang, the author of tcom
  #   
  ##########################################################################################################
  #package require optcl
 

  
  proc translate_text_with_systranbox_with_tcom { searchText translate_source_language translate_destination_language translate_used_website } {			 

		if { $searchText == "" } {
			 return ""
		} 
			 
	
		# Translate / Get HTML file from translator
		# examples  "http://www.systranbox.com/systran/box?lp=en_zh&text=hello"
	
			set head_string "http://www.systranbox.com/systran/box?"
		
			set langpair_string "lp="
			set connect_string "_"
			set transLangs "$translate_source_language$connect_string$translate_destination_language"	 
		
			set text_head_string "&text="
			set transfer_string [urlencode $searchText ]
		
			set url "$head_string$langpair_string$transLangs$text_head_string$transfer_string";
		
			# global request and XML document objects
			
				
				
			set ::msntranslator::req  [::optcl::new  Microsoft.XMLHTTP]

   
			#uuid(ED8C108D-4349-11D2-91A4-00C04F7969E8)
			# id(0x0000000e) onreadystatechange 
			

	 		
	 		#::optcl::bind  $::msntranslator::req   onreadystatechange processReqChange
	 		
      set url "http://translate.google.com/translate_t?text=hello&langpair=en|zh"
			status_log "url is $url"
			        
  		$::msntranslator::req  open  "GET"  $url  true
   	  $::msntranslator::req  send
   	  
   	  after 2500
     	if {[$::msntranslator::req :readyState] == 4} {   	
        # only if "OK"
  	 		status_log "msntranslator ready ok"      
        if {[$::msntranslator::req :status] == 200} {
   	 		status_log "msntranslator received ok [$::msntranslator::req :responseText]"           
            read_result_text [$::msntranslator::req :responseText]
         } else {
            status_log "msntranslate have a problem in  the XML data:\n [$::msntranslator::req statusText] "
         }    
      }
   
   }
   

 
  ##########################################################################################################   	
  # http data received event handler
  # 
  ##########################################################################################################   	
   
  
 
	proc processReqChange { args} {
      
      # only if req shows "loaded"
    	if {[$::msntranslator::req readyState] == 4} {   	
        # only if "OK"
        if {[$::msntranslator::req status] == 200} {
            read_result_text [$::msntranslator::req responseText]
         } else {
            status_log "msntranslate have a problem in  the XML data:\n [$::msntranslator::req statusText] "
         }    
      }
	}
  
   ##########################################################################################################   	
  # read result form systranbox return html
  # 
  ##########################################################################################################   	
  

	proc  read_result_text { html } {

				status_log "msntranslator html $html"		  	
		
		## Strip HTML before translated text 
		set substring "name=\"translation\""
		set start [expr [string first $substring $html] + 92]
		

		## Stript HTML after translated text
		set htmlPart [string range $html $start end]
		set end	[expr [string first "</textarea>" $htmlPart] - 1]
		set translation [string range $htmlPart 0 $end]
		
		set ::msntranslator::transltate_finished  1
    set ::msntranslator::translate_result 	$translation	
		return $translation	
	}


 
  ##########################################################################################################   	
  # translate text use systranbox website and http package
  # 
  ##########################################################################################################   	
   
   
  package require http 
   
   
  proc translate_text_with_systranbox { searchText translate_source_language translate_destination_language translate_used_website } {
  		status_log "begin "


		if { $searchText == "" } {
			 return ""
		} 
			 
		set connect_string "_"
		set transLangs "$translate_source_language$connect_string$translate_destination_language"	 
	 		status_log "transLangs is $transLangs "
		 
		# Translate / Get HTML file from translator
		set url "http://www.systranbox.com/systran/box"
		
		set query [::http::formatQuery systran_lp $transLangs systran_text  $searchText ]
		
		set http  [::http::geturl $url -query $query -timeout 72500  ]
		
		set html  [::http::data $http]
	  		
		
		# Strip HTML before translated text 
		set substring "name=\"translation\""
		set start [expr [string first $substring $html] + 92]
		

		
		# Stript HTML after translated text
		set htmlPart [string range $html $start end]
		set end	[expr [string first "</textarea>" $htmlPart] - 1]
		set translation [string range [string range $htmlPart 0 $end] 2 500]
		
		
		
		return [encoding convertfrom utf-8 $translation]
		
   }
   


 
  ##########################################################################################################   	
  # translate text use altavista website
  # 
  ##########################################################################################################   	
  
  
  proc translate_text_with_altavista { searchText translate_source_language translate_destination_language translate_used_website } {
  	
  		status_log "begin altavista "


		if { $searchText == "" } {
			 return ""
		} 
			 
		set connect_string "_"
		set transLangs "$translate_source_language$connect_string$translate_destination_language"	 
	 		status_log "transLangs is $transLangs "
		 
		 
		 
		# Translate / Get HTML file from translator
		set head_string "http://babelfish.altavista.com/tr?doit=done&intl=1&tt=urltext&trtext="
		set langpair_string "&lp="
		set transfer_string [urlencode  [encoding convertto utf-8 $searchText] ]
		
		set url "$head_string$transfer_string$langpair_string$transLangs";
		
		
		#set url "http://babelfish.altavista.com/tr"

		#set query [::http::formatQuery doit done intl 1  tt urltext trtext $searchText $langpair_string  $transLangs   ]
		#status_log "url is $url"
		set http  [::http::geturl $url -query $query -timeout 72500]
		set html  [::http::data $http]

		#	status_log "msntranslator html $html"
		
		# Strip HTML before translated text 
		set substring " name=\"q\" "
		set start [expr [string first $substring $html] + 8]
		

		
		# Stript HTML after translated text
		set htmlPart [string range $html $start end]
		set end	[expr [string first "\"><input type=\"hidden\" name=\"kls\"" $htmlPart] - 1]
		set translation  [string range [string range $htmlPart 0 $end] 9 200]
		#[encoding convertfrom unicode
		
		binary scan $translation H*@0a* hex ascii	  		


   status_log "translate result is [string bytelength $translation]  $hex "
   status_log " url en code is  [urlencode $translation]"
		return  $translation
		
   }
  
  

 
  ##########################################################################################################   	
  # translate text use google website
  # 
  ##########################################################################################################   	
  
  
  proc translate_text_with_google { searchText translate_source_language translate_destination_language translate_used_website } {
  	
  		status_log "begin google "


		if { $searchText == "" } {
			 return ""
		} 
			 
		set connect_string "|"
		set transLangs "$translate_source_language$connect_string$translate_destination_language"	 
	 		status_log "transLangs is $transLangs "
		 
		 
		# Translate / Get HTML file from translator
		set head_string "http://translate.google.com/translate_t?text="
		set langpair_string "&langpair="
		set transfer_string [urlencode $searchText ]
		set url "$head_string$transfer_string$langpair_string$transLangs";
		

		#set query [::http::formatQuery systran_lp $transLangs systran_text  $searchText ]
		
		set http  [::http::geturl $url  -timeout 72500]
		set html  [::http::data $http]
	  		
	  	
			status_log "msntranslator html $html"
		
		# Strip HTML before translated text 
		set substring "textarea name=q"
		set start [expr [string first $substring $html] + 37]
		

		
		# Stript HTML after translated text
		set htmlPart [string range $html $start end]
		set end	[expr [string first "</textarea>" $htmlPart] - 1]
		set translation [string range $htmlPart 0 $end]
		
	
		return [encoding convertfrom utf-8 $translation]
		
   }
  
  
		

  ##########################################################################################################   	
  # translate text test function ,just for debug
  # 
  ##########################################################################################################   	
	
  proc auto_translate_test { w } {
  
      set message_text  "   I love you   "
      set translate_source_language "en"
      set translate_destination_language "zh" 
      set translate_used_website "google"
  
      translate_text_with_altavista  $message_text $translate_source_language $translate_destination_language $translate_used_website 
  
  }

	
	
########################################################################
#end of namespace msntranslator	
#########################################################################
	
}

#end of namespace msntranslator	
	
	

	
 
